<?php
/**
 * @package Envs Switcher
 * @version 1.3.0
 */
defined('ABSPATH') or exit();

class slwsu_envs_switcher_admin_form {

    public static function validation() {
        if (isset($_GET['settings-updated'])) {
            delete_transient('slwsu_envs_switcher_options');
            ?>
            <div id="message" class="updated">
                <p><strong><?php echo __('Settings saved', 'ensw') ?></strong></p>
            </div>
            <?php
        }
    }

    public static function action() {
        ?>
        <a class="envs-switcher-modal-link" style="text-decoration:none; font-weight:bold;" href="#openModal"><?php echo __('About', 'ensw'); ?> <span class="dashicons dashicons-info"></span></a>
        <?php
    }

    public static function message($post) {
        ?>
        <div id="openModal" class="envs-switcher-modal">
            <div>
                <a href="#envs-switcher-modal-close" title="Close" class="envs-switcher-modal-close"><span class="dashicons dashicons-dismiss"></span></a>
                <h2><?php echo __('About', 'ensw'); ?></h2>
                <p><span class="dashicons dashicons-admin-users"></span> <?php echo __('By', 'ensw'); ?> <?php echo 'Steeve Lefebvre - slWsu'; ?></p>
                <p><span class="dashicons dashicons-admin-site"></span> <?php echo __('More information', 'ensw'); ?> : <a href="<?php echo 'https://web-startup.fr/envs-switcher/'; ?>" target="_blank"><?php _e('plugin page', 'ensw'); ?></a></p>
                <p><span class="dashicons dashicons-admin-tools"></span> <?php echo __('Development for the web', 'ensw'); ?> : HTML, PHP, JS, WordPress</p>
                <h2><?php echo __('Support', 'ensw'); ?></h2>
                <p><span class="dashicons dashicons-email-alt"></span> <?php echo __('Ask your question', 'ensw'); ?></p>
                <?php
                if (isset($post['submit'])) {
                    global $current_user; $to = 'steeve.lfbvr@gmail.com'; $subject = "Support Grouper !!!";
                    $roles = implode(", ", $current_user->roles);
                    $message = "From: " . get_bloginfo('name') . " - " . get_bloginfo('home') . " - " . get_bloginfo('admin_email') . "\n";
                    $message .= "By : " . strip_tags($post['nom']) . " - " . $post['email'] . " - " . $roles . "\n";
                    $message .= strip_tags($post['message']) . "\n";
                    if (wp_mail($to, $subject, $message)):
                        echo '<p class="envs-switcher-contact-valide"><strong>' . __('Your message has been sent !', 'ensw') . '</strong></p>';
                    else:
                        echo '<p class="envs-switcher-contact-error">' . __('Something went wrong, go back and try again !', 'ensw') . '</p>';
                    endif;
                }
                ?>
                <form id="envs-switcher-contact" action="" method="post">
                    <fieldset>
                        <input id="nom" name="nom" type="text" placeholder="<?php echo __('Your name', 'ensw'); ?>" required="required">
                    </fieldset>
                    <fieldset>
                        <input id="email" name="email" type="email" placeholder="<?php echo __('Your Email Address', 'ensw'); ?>" required="required">
                    </fieldset>
                    <fieldset>
                        <textarea id="message" name="message" placeholder="<?php echo __('Formulate your support request or feature proposal here...', 'ensw'); ?>" required="required"></textarea>
                    </fieldset>
                    <fieldset>
                        <input id="submit" name="submit" type="submit" value="<?php echo __('Send', 'ensw'); ?>" class="button button-primary" type="submit" id="envs-switcher-contact-submit" data-submit="...Sending" />
                    </fieldset>
                </form>
            </div>
        </div>
        <?php
    }

}
