<?php
/**
 * @package Envs Switcher
 * @version 1.3.0
 */
defined('ABSPATH') or exit();

include_once plugin_dir_path(__FILE__) . 'form.php';

class slwsu_envs_switcher_admin_page {

    /**
     *
     */
    public function __construct() {
        $this->_init();
    }

    /**
     *
     */
    private function _init() {
        add_action('admin_menu', array($this, 'admin_menu'));
        add_action('admin_init', array($this, 'admin_settings'));
        add_action('admin_head', array($this, 'admin_css'));
    }

    /**
     * ...
     */
    public function admin_menu() {
        global $ENVS_SWITCHER_PLUGIN;
        if (is_object($ENVS_SWITCHER_PLUGIN)):
            // Grouper
            $ENVS_SWITCHER_PLUGIN->add_admin_menu();
            add_submenu_page($ENVS_SWITCHER_PLUGIN->grp_id, 'Envs Switcher', 'Envs Switcher', 'manage_options', 'envs-switcher', array($this, 'admin_page'));
        else:
            add_menu_page('Envs Switcher', 'Envs Switcher', 'activate_plugins', 'envs-switcher', array($this, 'admin_page'));
        endif;
    }

    /**
     * ...
     */
    public function admin_page() {
        ?>
        <div class="wrap">
            <?php
            slwsu_envs_switcher_admin_form::action();
            echo '<h1>Envs Switcher</h1>';
            slwsu_envs_switcher_admin_form::validation();
            slwsu_envs_switcher_admin_form::message($_POST);
            ?>
            <form method="post" action="options.php">
                <?php
                do_settings_sections('slwsu_envs_switcher_options');
                settings_fields('slwsu_envs_switcher_settings');
                submit_button();
                ?>
            </form>
        </div>
        <?php
    }

    /**
     *
     */
    public function admin_settings() {
        // Section plugin
        add_settings_section(
                'slwsu_envs_switcher_section_plugin', __('General', 'ensw'), array($this, 'section_plugin'), 'slwsu_envs_switcher_options'
        );

        add_settings_field(
                'slwsu_envs_switcher_environement', __('Environment', 'ensw'), array($this, 'environement'), 'slwsu_envs_switcher_options', 'slwsu_envs_switcher_section_plugin'
        );
        register_setting(
                'slwsu_envs_switcher_settings', 'slwsu_envs_switcher_environement'
        );

        add_settings_field(
                'slwsu_envs_switcher_localhost', __('Local dir name', 'ensw'), array($this, 'localhost'), 'slwsu_envs_switcher_options', 'slwsu_envs_switcher_section_plugin'
        );
        register_setting(
                'slwsu_envs_switcher_settings', 'slwsu_envs_switcher_localhost'
        );

        add_settings_field(
                'slwsu_envs_switcher_developpement', __('Dev Url', 'ensw'), array($this, 'developpement'), 'slwsu_envs_switcher_options', 'slwsu_envs_switcher_section_plugin'
        );
        register_setting(
                'slwsu_envs_switcher_settings', 'slwsu_envs_switcher_developpement'
        );

        add_settings_field(
                'slwsu_envs_switcher_production', __('Prod Url', 'ensw'), array($this, 'production'), 'slwsu_envs_switcher_options', 'slwsu_envs_switcher_section_plugin'
        );
        register_setting(
                'slwsu_envs_switcher_settings', 'slwsu_envs_switcher_production'
        );

        add_settings_field(
                'slwsu_envs_switcher_demonstration', __('Demo Url', 'ensw'), array($this, 'demonstration'), 'slwsu_envs_switcher_options', 'slwsu_envs_switcher_section_plugin'
        );
        register_setting(
                'slwsu_envs_switcher_settings', 'slwsu_envs_switcher_demonstration'
        );

        add_settings_field(
                'slwsu_envs_switcher_test', __('Test Url', 'ensw'), array($this, 'test'), 'slwsu_envs_switcher_options', 'slwsu_envs_switcher_section_plugin'
        );
        register_setting(
                'slwsu_envs_switcher_settings', 'slwsu_envs_switcher_test'
        );

        // Section options
        add_settings_section(
                'slwsu_envs_switcher_section_options', __('Deactivation', 'ensw'), array($this, 'section_options'), 'slwsu_envs_switcher_options'
        );
        add_settings_field(
                'slwsu_envs_switcher_delete_options', __('Delete options', 'ensw'), array($this, 'delete_options'), 'slwsu_envs_switcher_options', 'slwsu_envs_switcher_section_options'
        );
        register_setting(
                'slwsu_envs_switcher_settings', 'slwsu_envs_switcher_delete_options'
        );

        /**
         * Support GRP
         */
        if ('true' === get_option('slwsu_is_active_grouper', 'false')):
            // Section grouper
            add_settings_section(
                    'slwsu_envs_switcher_section_grouper', __('Group', 'ensw'), array($this, 'section_grouper'), 'slwsu_envs_switcher_options'
            );
            // ...
            add_settings_field(
                    'slwsu_envs_switcher_grouper', __('Plugin Group', 'ensw'), array($this, 'grouper_nom'), 'slwsu_envs_switcher_options', 'slwsu_envs_switcher_section_grouper'
            );
            register_setting(
                    'slwsu_envs_switcher_settings', 'slwsu_envs_switcher_grouper'
            );
        else:
            // Section NO grouper
            add_settings_section(
                    'slwsu_envs_switcher_section_grouper', null, array($this, 'section_grouper_no'), 'slwsu_envs_switcher_options'
            );
        endif;
    }

    /**
     * Plugin
     */
    public function section_plugin() {
        echo __('This section concerns the configuration of the plugin', 'ensw') . '&nbsp;<strong><i>Envs Switcher</i></strong>';
    }

    /**
     * Options
     */
    public function section_options() {
        echo __('This section is about saving plugin options of', 'ensw') . '&nbsp;<strong><i>Envs Switcher</i></strong>';
    }

    function environement() {
        $env = get_option('slwsu_envs_switcher_environement');
        ?>
        <input name="slwsu_envs_switcher_environement" type="radio" value="developpement" <?php if ('developpement' == $env) echo 'checked="checked"'; ?> />
        <span class="description"><?php echo __('Development', 'ensw'); ?></span> <span class="description">
            &nbsp;
            <input name="slwsu_envs_switcher_environement" type="radio" value="production" <?php if ('production' == $env) echo 'checked="checked"'; ?> />
            <span class="description"><?php echo __('Production', 'ensw'); ?></span>
            &nbsp;
            <input name="slwsu_envs_switcher_environement" type="radio" value="demonstration" <?php if ('demonstration' == $env) echo 'checked="checked"'; ?> />
            <span class="description"><?php echo __('Demonstration', 'ensw'); ?></span>
            &nbsp;
            <input name="slwsu_envs_switcher_environement" type="radio" value="test" <?php if ('test' == $env) echo 'checked="checked"'; ?> />
            <span class="description"><?php echo __('Test', 'ensw'); ?></span>
            <br />
            <span class="description"><?php echo __('Choose this environment, must be defined as the current environment.', 'ensw'); ?> </span>
            <?php
        }

        public function localhost() {
            $input = get_option('slwsu_envs_switcher_localhost');
            echo '<input id="slwsu_envs_switcher_localhost" name="slwsu_envs_switcher_localhost" value="' . $input . '" type="text" class="text" />';
            echo '<span class="description"> ' . __('Ex : my-web-site', 'ensw') . '</span>';
            echo '<p class="description">' . __('Local environment only : If you use localhost for development, ad here the name of the folder on your local site.', 'ensw') . '</p>';
        
        }

        public function developpement() {
            $input = get_option('slwsu_envs_switcher_developpement');
            echo '<input id="slwsu_envs_switcher_developpement" name="slwsu_envs_switcher_developpement" value="' . $input . '" type="text" class="regular-text" />';
            echo '<p class="description">' . __('Url of the development platform.', 'ensw') . '</p>';
        }

        public function production() {
            $input = get_option('slwsu_envs_switcher_production');
            echo '<input id="slwsu_envs_switcher_production" name="slwsu_envs_switcher_production" value="' . $input . '" type="text" class="regular-text" />';
            echo '<p class="description">' . __('URL of the production platform.', 'ensw') . '</p>';
        }

        public function demonstration() {
            $input = get_option('slwsu_envs_switcher_demonstration');
            echo '<input id="slwsu_envs_switcher_demonstration" name="slwsu_envs_switcher_demonstration" value="' . $input . '" type="text" class="regular-text" />';
            echo '<p class="description">' . __('URL of the demonstration platform.', 'ensw') . '</p>';
        }

        public function test() {
            $input = get_option('slwsu_envs_switcher_test');
            echo '<input id="slwsu_envs_switcher_test" name="slwsu_envs_switcher_test" value="' . $input . '" type="text" class="regular-text" />';
            echo '<p class="description">' . __('URL of the test platform.', 'ensw') . '</p>';
        }
        
        public function delete_options() {
            $input = get_option('slwsu_envs_switcher_delete_options');
            ?>
            <input name="slwsu_envs_switcher_delete_options" type="radio" value="true" <?php if ('true' == $input) echo 'checked="checked"'; ?> />
            <span class="description">On</span>
            &nbsp;
            <input name="slwsu_envs_switcher_delete_options" type="radio" value="false" <?php if ('false' == $input) echo 'checked="checked"'; ?> />
            <span class="description">Off</span>
            &nbsp;-&nbsp;
            <span class="description"><?php echo __('Delete plugin options when disabling.', 'ensw'); ?> </span>
        <?php
    }

    /**
     * Support GRP
     */
    public function section_grouper() {
        echo __('This section concerns the Grouper plugin group of', 'ensw') . '&nbsp;<strong><i>Envs Switcher</i></strong>';
    }

    public function grouper_nom() {
        $input = get_option('slwsu_envs_switcher_grouper', 'Grouper');
        echo '<input id="slwsu_envs_switcher_grouper" name="slwsu_envs_switcher_grouper" value="' . $input . '" type="text" class="regular-text" />';
        echo '<p class="description">' . __('Specify here the Grouper group to attach', 'ensw') . '&nbsp;<strong><i>Envs Switcher</i></strong>.</p>';
        echo '<p>' . __('WARNING :: changing the value of this field amounts to modifying the name of the parent link in the WordPress admin menu !', 'ensw') . '</p>';
        echo '<p>' . __('You can use this option to isolate this plugin or to add this plugin to an existing Grouper group.', 'ensw') . '</p>';
    }

    public function section_grouper_no() {
        echo '<strong><i>Envs Switcher</i></strong> ' . __('is compatible with Grouper', 'ensw');
        if (file_exists(WP_PLUGIN_DIR . '/grouper')):
            echo '.<br />Grouper ' . __('is installed but does not appear to be enabled', 'ensw') . ' : ';
            echo '<a href="plugins.php">' . __('you can activate', 'ensw') . ' Grouper</a>';
        else:
            echo ' : <a href="https://web-startup.fr/grouper/" target="_blank">' . __('more information here', 'ensw') . '</a>.';
        endif;
    }

    /**
     *
     */
    public function admin_css() {
        echo '<style>
            .envs-switcher-modal-link {
                position: relative;
                float: right;
            }

            .envs-switcher-modal {
                top: 0;
                left: 0;
                right: 0;
                bottom: 0;
                opacity: 0;
                z-index: 99999;
                position: fixed;
                pointer-events: none;
                background: rgba(0,0,0,0.8);
                font-family: Arial, Helvetica, sans-serif;
                -webkit-transition: opacity 250ms ease-in;
                -moz-transition: opacity 250ms ease-in;
                transition: opacity 250ms ease-in;
            }

            .envs-switcher-modal:target {
                opacity: 1;
                pointer-events: auto;
            }

            .envs-switcher-modal > div {
                width: 400px;
                background: #fff;
                margin: 7% auto;
                position: relative;
                border-radius: 10px;
                padding: 5px 20px 13px 20px;
                background: -o-linear-gradient(bottom, rgb(245,245,245) 25%, rgb(232,232,232) 63%);
                background: -moz-linear-gradient(bottom, rgb(245,245,245) 25%, rgb(232,232,232) 63%);
                background: -webkit-linear-gradient(bottom, rgb(245,245,245) 25%, rgb(232,232,232) 63%);
            }

            .envs-switcher-modal-close {
                top: 10px;
                right: 10px;
                font-weight: bold;
                position: absolute;
                text-align: center;
                text-decoration: none;
            }

            .envs-switcher-modal-close:hover { color: #333; }

            #envs-switcher-contact input[type="text"],
            #envs-switcher-contact input[type="email"],
            #envs-switcher-contact input[type="url"],
            #envs-switcher-contact textarea,
            #envs-switcher-contact button[type="submit"] {
                font:400 12px/16px "Open Sans", Helvetica, Arial, sans-serif;
            }

            fieldset {
                border: medium none !important;
                margin: 0 0 6px;
                min-width: 100%;
                padding: 0;
                width: 100%;
            }

            #envs-switcher-contact input[type="text"],
            #envs-switcher-contact input[type="email"],
            #envs-switcher-contact input[type="tel"],
            #envs-switcher-contact input[type="url"],
            #envs-switcher-contact textarea {
                width:100%;
                border:1px solid #CCC;
                background:#FFF;
                margin:0 0 5px;
                padding:10px;
            }

            #envs-switcher-contact input[type="text"]:hover,
            #envs-switcher-contact input[type="email"]:hover,
            #envs-switcher-contact input[type="tel"]:hover,
            #envs-switcher-contact input[type="url"]:hover,
            #envs-switcher-contact textarea:hover {
                -webkit-transition:border-color 0.3s ease-in-out;
                -moz-transition:border-color 0.3s ease-in-out;
                transition:border-color 0.3s ease-in-out;
                border:1px solid #AAA;
            }

            #envs-switcher-contact textarea {
                height:100px;
                max-width:100%;
                resize:none;
                margin-bottom: 0px;
            }

            #envs-switcher-contact input:focus,
            #envs-switcher-contact textarea:focus {
                outline:0;
                border:1px solid #999;
            }

            ::-webkit-input-placeholder { color:#888; }
            :-moz-placeholder { color:#888; }
            ::-moz-placeholder { color:#888; }
            :-ms-input-placeholder { color:#888; }


            .envs-switcher-contact-valide, .envs-switcher-contact-error{
                padding: 8px;
                background-color: white;
            }
            .envs-switcher-contact-valide{
                border-left: 4px solid #46b450;
            }
            .envs-switcher-contact-error{
                border-left: 4px solid #dc3232;
            }
        </style>';
    }

}
